//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1  Orange
#property indicator_width1  2

//
//
//
//
//

extern int HalfLength11 = 25;
extern int HalfLength12 = 13;
extern int HalfLength21 = 50;
extern int HalfLength22 = 26;
extern int Price1       = PRICE_CLOSE;
extern int Price2       = PRICE_CLOSE;

double buffer1[];
double buffer2[];
double buffer3[];
double slope1[];
double slope2[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//

int init()
{
   IndicatorDigits(6);
   IndicatorBuffers(5);
   SetIndexBuffer(0,buffer1);
   SetIndexBuffer(1,buffer2);
   SetIndexBuffer(2,buffer3);
   SetIndexBuffer(3,slope1);
   SetIndexBuffer(4,slope2);
   return(0);
}
int deinit() { return(0); }




//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double work[][18];
int start()
{
   int i,r,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars+MathMax(MathMax(MathMax(HalfLength11,HalfLength12),HalfLength21),HalfLength22)*5,Bars-1);
           if (ArrayRange(work,0)!=Bars) ArrayResize(work,Bars);

   //
   //
   //
   //
   //
   
   for (i=limit, r=Bars-i-1; i>=0; i--,r++)
   {
      work[r][0] = iMA(NULL,0,1,0,MODE_SMA,Price1,i);
      work[r][9] = iMA(NULL,0,1,0,MODE_SMA,Price2,i);
   }      
   iCSmao(limit, HalfLength11, HalfLength12,buffer2,slope1,0);
   iCSmao(limit, HalfLength21, HalfLength22,buffer3,slope2,1);
   for (i=limit; i>=0; i--)
   {
      buffer1[i] = 0.5;
         if (slope1[i]== 1 && slope2[i]== 1) buffer1[i] = 1;
         if (slope1[i]==-1 && slope2[i]==-1) buffer1[i] = 0;
   }   
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void iCSmao(int limit, int HalfLength1, int HalfLength2, double& buffer[], double& slope[], int instance=0)
{
   int i,r; instance *=9;
   for (i=limit, r=Bars-i-1; i>=0; i--,r++)
   {
      work[r][instance+1] = iCTma(instance+0,HalfLength1,i);
      work[r][instance+2] = iCTma(instance+0,HalfLength2,i);
      work[r][instance+3] = 100.0*(work[r][instance+1]-work[r][instance+2]);
   }
   for (i=limit, r=Bars-i-1; i>=0; i--,r++)
   {
      work[r][instance+4] = iCTma(instance+3,HalfLength2,i);
      work[r][instance+5] = 100.0*(work[r][instance+4]-work[r-1][instance+4]);
   }
   for (i=limit, r=Bars-i-1; i>=0; i--,r++)
   {
      work[r][instance+6] = iCTma(instance+5,HalfLength2,i);
      work[r][instance+7] = 100.0*(work[r][instance+6]-work[r-1][instance+6]);
   }
   for (i=limit, r=Bars-i-1; i>=0; i--,r++)
   {
      work[r][instance+8] = iCTma(instance+7,HalfLength2,i);
      buffer[i]  = work[r][instance+8];
      slope[i]   = slope[i+1];
            if (buffer[i]>buffer[i+1]) slope[i]= 1;
            if (buffer[i]<buffer[i+1]) slope[i]=-1;
   }            
}

//
//
//
//
//

double iCTma(int useValue, int halfLength, int i)
{
   i = Bars-i-1;
   
   //
   //
   //
   //
   //
      
   double sum  = (halfLength+1)*work[i][useValue];
   double sumw = (halfLength+1);
 
      //
      //
      //
      //
      //
 
      int j,k = halfLength; 
      for(j=1; j<=halfLength; j++,k--)
      {
         sum  += k*work[i-j][useValue];
         sumw += k;
            int l = MathMin(j+i,Bars-1);
               sum  += k*work[l][useValue];
               sumw += k;
      }
   return(sum/sumw);      
}